
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef worldModelGrid3DG_TCLSERV_CLIENT_ERROR_H
#define worldModelGrid3DG_TCLSERV_CLIENT_ERROR_H

#include <server/worldModelGrid3DGError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum worldModelGrid3DG_error {
	E_worldModelGrid3DG_OK					  			= 0,

	/* module errors */
	E_worldModelGrid3DG_IMPORT_MAP_FAILURE             = S_worldModelGrid3DG_IMPORT_MAP_FAILURE,
	E_worldModelGrid3DG_Refresh_MAP_FAILURE            = S_worldModelGrid3DG_Refresh_MAP_FAILURE,
	E_worldModelGrid3DG_SET_ROBOT_BOX_FREE_FAILURE     = S_worldModelGrid3DG_SET_ROBOT_BOX_FREE_FAILURE,
	E_worldModelGrid3DG_SET_ROBOT_POS_FAILURE          = S_worldModelGrid3DG_SET_ROBOT_POS_FAILURE,
	E_worldModelGrid3DG_CLEAR_MAP_FAILURE              = S_worldModelGrid3DG_CLEAR_MAP_FAILURE,
	E_worldModelGrid3DG_EXPORTING_VRML_MAP_FAILURE     = S_worldModelGrid3DG_EXPORTING_VRML_MAP_FAILURE,
	E_worldModelGrid3DG_EXPORTING_MAP_FAILURE          = S_worldModelGrid3DG_EXPORTING_MAP_FAILURE,
	E_worldModelGrid3DG_UPDATING_MAP_FAILURE           = S_worldModelGrid3DG_UPDATING_MAP_FAILURE,
	E_worldModelGrid3DG_MAKING_SOLID_BOX_FAILURE       = S_worldModelGrid3DG_MAKING_SOLID_BOX_FAILURE,
	E_worldModelGrid3DG_MAKING_FREE_BOX_FAILURE        = S_worldModelGrid3DG_MAKING_FREE_BOX_FAILURE,
	E_worldModelGrid3DG_SETTING_FREE_BOX_FAILURE       = S_worldModelGrid3DG_SETTING_FREE_BOX_FAILURE,
	E_worldModelGrid3DG_ALLOCATING_MAP_FAILURE         = S_worldModelGrid3DG_ALLOCATING_MAP_FAILURE,
	E_worldModelGrid3DG_SETTING_CAMERA_PARAMETERS_FAILURE = S_worldModelGrid3DG_SETTING_CAMERA_PARAMETERS_FAILURE,
	E_worldModelGrid3DG_SETTING_SENSITIVITY_FAILURE    = S_worldModelGrid3DG_SETTING_SENSITIVITY_FAILURE,
	E_worldModelGrid3DG_SETTING_RESOLUTION_FAILURE     = S_worldModelGrid3DG_SETTING_RESOLUTION_FAILURE,
	E_worldModelGrid3DG_INITIALIZATION_FAILURE         = S_worldModelGrid3DG_INITIALIZATION_FAILURE,


	/* std errors */
	E_worldModelGrid3DG_ACTIVITY_INTERRUPTED           = S_worldModelGrid3DG_stdGenoM_ACTIVITY_INTERRUPTED,
	E_worldModelGrid3DG_TOO_MANY_ACTIVITIES            = S_worldModelGrid3DG_stdGenoM_TOO_MANY_ACTIVITIES,
	E_worldModelGrid3DG_ACTIVITY_FAILED                = S_worldModelGrid3DG_stdGenoM_ACTIVITY_FAILED,
	E_worldModelGrid3DG_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_worldModelGrid3DG_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_worldModelGrid3DG_UNKNOWN_ACTIVITY               = S_worldModelGrid3DG_stdGenoM_UNKNOWN_ACTIVITY,
	E_worldModelGrid3DG_FORBIDDEN_ACTIVITY_TRANSITION  = S_worldModelGrid3DG_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_worldModelGrid3DG_SYSTEM_ERROR                   = S_worldModelGrid3DG_stdGenoM_SYSTEM_ERROR,
	E_worldModelGrid3DG_ACTIVITY_ALREADY_ENDED         = S_worldModelGrid3DG_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_worldModelGrid3DG_WAIT_INIT_RQST                 = S_worldModelGrid3DG_stdGenoM_WAIT_INIT_RQST,
	E_worldModelGrid3DG_CONTROL_CODEL_ERROR            = S_worldModelGrid3DG_stdGenoM_CONTROL_CODEL_ERROR,
	E_worldModelGrid3DG_EXEC_TASK_SUSPENDED            = S_worldModelGrid3DG_stdGenoM_EXEC_TASK_SUSPENDED,
	E_worldModelGrid3DG_BAD_BLOCK_TYPE                 = S_worldModelGrid3DG_stdGenoM_BAD_BLOCK_TYPE,
	E_worldModelGrid3DG_BAD_POSTER_TYPE                = S_worldModelGrid3DG_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum worldModelGrid3DG_error worldModelGrid3DG_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int worldModelGrid3DG_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the worldModelGrid3DG context.
 *
 * Returns NULL in case of failure
 */
const char* worldModelGrid3DG_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
